VERSION 5.00
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "MSCOMCTL.OCX"
Begin VB.Form frmMain 
   Caption         =   "Dynamic Instantation of User Controls"
   ClientHeight    =   4455
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   7725
   LinkTopic       =   "Form1"
   ScaleHeight     =   4455
   ScaleWidth      =   7725
   StartUpPosition =   3  'Windows Default
   Begin VB.Frame framContainer 
      Caption         =   "Container"
      Height          =   3855
      Left            =   2280
      TabIndex        =   0
      Top             =   240
      Width           =   5055
   End
   Begin MSComctlLib.TreeView TreeView1 
      Height          =   3855
      Left            =   360
      TabIndex        =   1
      Top             =   240
      Width           =   1695
      _ExtentX        =   2990
      _ExtentY        =   6800
      _Version        =   393217
      Style           =   7
      Appearance      =   1
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Sub Form_Load()
    Dim objNode As Node
    
    With TreeView1
    
        .Nodes.Clear
    
        Set objNode = .Nodes.Add(, , "root", "Applications")
        Set objNode = .Nodes.Add("root", tvwChild, "Calculator", "Calculator")
        Set objNode = .Nodes.Add("root", tvwChild, "Calendar", "Calendar")
        Set objNode = .Nodes.Add("root", tvwChild, "Multimedia", "Multimedia")
        
                    
       .Nodes(1).Expanded = True
        
    End With
    
End Sub


Private Sub TreeView1_NodeClick(ByVal Node As MSComctlLib.Node)
    Dim objCalc As Object
    
        Call RemoveApplication("Application1")
        Call RemoveApplication("Application2")
        Call RemoveApplication("Application3")
    
    If Node.Text = "Calculator" Then
        If CheckLicense("CALC_OCX.userCalculator") = False Then
            Licenses.Add "CALC_OCX.userCalculator"
        End If
        
        Set objCalc = Me.Controls.Add("CALC_OCX.userCalculator", "Application1", framContainer)
         

        objCalc.Visible = True
        
        framContainer.Width = objCalc.Width
        framContainer.Height = objCalc.Height
        
    ElseIf Node.Text = "Calendar" Then
        
        If CheckLicense("CALC_OCX.userCalendar") = False Then
            Licenses.Add "CALC_OCX.userCalendar"
        End If
        
        Set objCalc = Me.Controls.Add("CALC_OCX.userCalendar", "Application2", framContainer)
         
        objCalc.Visible = True
        
        framContainer.Width = objCalc.Width
        framContainer.Height = objCalc.Height
   
    ElseIf Node.Text = "Multimedia" Then
        
        If CheckLicense("CALC_OCX.usermultimedia") = False Then
            Licenses.Add "CALC_OCX.usermultimedia"
        End If
        
        Set objCalc = Me.Controls.Add("CALC_OCX.usermultimedia", "Application3", framContainer)
         
        objCalc.Visible = True
        
        framContainer.Width = objCalc.Width
        framContainer.Height = objCalc.Height
    
    End If
    
End Sub

Private Function CheckLicense(sProgID As String) As Boolean

 Dim objLicense As LicenseInfo
 
 For Each objLicense In Licenses
  If objLicense.ProgID = sProgID Then
   CheckLicense = True
   Exit Function
  End If
 Next

 CheckLicense = False

End Function

Private Sub RemoveApplication(sApplication As String)
    Dim objControl As Control
    
        For Each objControl In Me.Controls
            If objControl.Name = sApplication Then
                Me.Controls.Remove sApplication
            End If
        Next
End Sub
